'Odtwarzacz CD (EP)
'Marcin Wizania
'marcin.wiazania@ep.com.pl

$prog &HFF , &HE2 , &HD9 , &HFF                             'ustawienie fuse bit
$hwstack = 80                                               'ustawienie stosu
$swstack = 80       'ustawienie stosu
$framesize = 80  'ustawienie stosu

$regfile = "m162def.dat"                                    'typ mikrokontrolera
$crystal = 8000000                                          'czestotliwosc kwarcu

Config Rc5 = Pind.2                                         'konfiguracja rc5
Config Watchdog = 1024
Stop Watchdog
Config Lcd = 16 * 2                                         'konfiguracja lcd
Config Lcdpin = Pin , Db4 = Portb.3 , Db5 = Portb.2 , Db6 = Portb.1 , Db7 = Portb.0 , E = Portb.4 , Rs = Portd.4       'konfiguracja lcd
Config Clock = User                                         'konfiguracja rtc
Config Date = Dmy , Separator = -                           'ponfiguracja daty
Config Timer1 = Timer , Prescale = 256                      'konfiguracja licznika odmierzajacego czas
Config Porta = Input                                        'konfiguracja portow
Config Portc = Input
Config Pinb.0 = Output
Config Pinb.5 = Input
Config Pinb.6 = Input
Config Pinb.7 = Input
Config Pind.0 = Output
Config Pind.1 = Output
Config Pind.3 = Input
Config Pind.5 = Output
Config Pine.1 = Input
Config Pine.0 = Output
Config Pine.2 = Output
Disable Interrupts

On Timer1 Odm_1s                                            'konfiguracja przerwania od timer1

Diow Alias Portd.0                                          'przypisanie aliasow
Dior Alias Portd.1
Zat Alias Portd.5
Intrq Alias Pind.3
W1 Alias Pinb.5
W2 Alias Pinb.6
W3 Alias Pinb.7
On_off Alias Pine.1
Led_off Alias Porte.0
Lcd_off Alias Porte.2

Dim Conf As Byte                                            'zmienne wykorzystywane w programie
Dim Dane_l As Byte
Dim Dane_h As Byte
Dim Error As Byte
Dim Status As Byte
Dim Dlug_pak As Byte
Dim I As Byte
Dim J As Byte
Dim Flaga1 As Bit
Dim Flaga2 As Bit
Dim Flaga3 As Bit
Dim Flaga4 As Bit
Dim Pakiet(16) As Byte
Dim Ilosc_track As Byte
Dim P_m As Byte
Dim P_s As Byte
Dim P_f As Byte
Dim K_m As Byte
Dim K_s As Byte
Dim K_f As Byte
Dim Track As Byte
Dim Track_temp As Byte
Dim Track_odtw As Byte
Dim Temp1 As Byte
Dim Temp2 As Byte
Dim Temp3 As Byte
Dim Temp4 As Byte
Dim Abs_m As Byte
Dim Abs_s As Byte
Dim Abs_f As Byte
Dim Rel_m As Byte
Dim Rel_s As Byte
Dim Rel_f As Byte
Dim Aud_stat As Byte
Dim Pause_s As Byte
Dim Pause_f As Byte
Dim Tmp1_m As Byte
Dim Tmp2_s As Byte
Dim Tmp3_f As Byte
Dim Tmp4_m As Byte
Dim Tmp5_s As Byte
Dim Tmp6_f As Byte
Dim Kon_m As Byte
Dim Kon_s As Byte
Dim Kon_f As Byte
Dim Fr_c As Byte
Dim Kod_kl As Byte
Dim N As Byte
Dim Tmp_w1 As Byte
Dim Tmp_w2 As Byte
Dim Tmp_w3 As Byte
Dim Tmp_w4 As Byte
Dim Napis As String * 5
Dim Z_nap As Bit
Dim Czas As Bit
Dim S_czyt As Bit
Dim Zm_pause As Byte
Dim Zm_track As Bit
Dim K_tr As Byte
Dim Przewin As Byte
Dim Address As Byte
Dim Command As Byte
Dim Flag_on As Bit
Dim U_clk As Bit
Dim Rc(10) As Byte
Dim F_rc As Bit
Dim Temp10 As Byte
Dim Adres As Byte
Dim K As Byte
Dim V As Byte
Dim Setup As Bit
Dim U_t(6) As Byte
Dim U_tp As Byte
Dim U_tk As Byte
Dim W_track(100) As Byte
Dim X As Byte

Declare Sub Write_1b                                        'procedury wykorzystywane w programie
Declare Sub Write_2b
Declare Sub Read_1b
Declare Sub Read_2b
Declare Sub Pob_h_r
Declare Sub Pob_l_r
Declare Sub Wys_h_r
Declare Sub Wys_l_r
Declare Sub Wys_kom_reg
Declare Sub Pob_dane
Declare Sub Wys_dane2b
Declare Sub Wys_dane1b
Declare Sub Wys_wyb_nap
Declare Sub Pob_wyb_nap
Declare Sub Pob_err
Declare Sub Pob_int
Declare Sub Pob_stat
Declare Sub Init_cd
Declare Sub Bsy_czek
Declare Sub Bsy_drdy_czek
Declare Sub Csa
Declare Sub Ident_nap
Declare Sub Czek_int
Declare Sub Blad_cd
Declare Sub Reszt_dan
Declare Sub Czek_az_got
Declare Sub Test_got_cmd
Declare Sub Zer_pak
Declare Sub Drq_czek
Declare Sub Ndrq_czek
Declare Sub Wysl_pak
Declare Sub Odczyt_toc
Declare Sub Blad_pak
Declare Sub Odczyt_dan_toc
Declare Sub Pob_msf
Declare Sub Odczyt_subchan
Declare Sub Pob_dan_subchan
Declare Sub Pause_track
Declare Sub Play_track
Declare Sub Stop_track
Declare Sub Odejmij_czas
Declare Sub Forma_czas
Declare Sub Klawiatura
Declare Sub Wyswietl
Declare Sub Warunki_play
Declare Sub Zatrzasnij
Declare Sub Rc5
Declare Sub Ustawienia
Declare Sub Sel_track

Porta = 0                                                   'przypisanie zmiennym wartosci poczatkowych
Portc = 0
Reset Lcd_off
Set Portb.5
Set Portb.6
Set Portb.7
Set Porte.1
Reset Zat
Reset Flag_on
Status = 0
Error = 0
Conf = 0
Track = 1
Zm_pause = 1
Zm_track = 0
K_tr = 1
Reset U_clk
Set Diow
Set Dior
Set Portd.2
_sec = 0
_min = 0
_hour = 12
_day = 1
_month = 1
_year = 5
Reset Setup

Rc(1) = 0                                                   'zapis domyslnych kodow pilota rc5 do EEPROM
Rc(2) = 1
Rc(3) = 2
Rc(4) = 3
Rc(5) = 4
Rc(6) = 5
Rc(7) = 6
Rc(8) = 7
Rc(9) = 8
Rc(10) = 9
Readeeprom Temp10 , 20
If Temp10 <> 5 Then
  Temp10 = 5
  Writeeeprom Temp10 , 20
  For K = 1 To 10
    Writeeeprom Rc(k) , K
  Next K
End If
For K = 1 To 10
  Readeeprom Rc(k) , K
Next K

Cls                                                         'konfiguracja LCD oraz odczyt parametrow CD-ROMu
Cursor Off
Enable Interrupts
Enable Timer1
Counter1 = 34286
Wait 1
Call Init_cd                                                'inicjacja napedu
Call Ident_nap

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Do                                                          'poczatek programu glownego
  Do
    Debounce On_off , 0 , Onoff , Sub                       'obsluga przycisku ON_OFF
    Call Rc5
    If Flag_on = 1 Then
      For K = 1 To 10
        Readeeprom Rc(k) , K                                'odczyt kodow pilota z pamieci EEPROM
      Next K
      Set Led_off
      Set Lcd_off
      Cls
      Lcd "    Power ON"
      Wait 1
      Cls

Poczatek_p:
      Debounce On_off , 0 , Onoff , Sub                     'obsluga przycisku ON_OFF
      Call Rc5
      If Flag_on = 0 Then
        Cls
        Exit Do
      End If

Poczatek:
      Debounce On_off , 0 , Onoff , Sub                     'obsluga przycisku ON_OFF
      Call Rc5
      If Flag_on = 0 Then
        Cls
        Exit Do
      End If
      Tmp_w1 = 0
      Tmp_w2 = 0
      Tmp_w3 = 0
      Tmp_w4 = 0
      Fr_c = 1
      Cls
      Wait 1
      Track = 1
      Call Czek_az_got                                      'sprawdzanie gotowosci napedu
      If Flaga1 = 0 Then                                    'Jezeli flaga1=0 to brak plyty CD
        Lcd "No Disc"
        For V = 1 To 100
          W_track(v) = 1
        Next V
      End If
      Do
        Call Czek_az_got
        Debounce On_off , 0 , Onoff , Sub
        Call Rc5
        If Flag_on = 0 Then
          Cls
          Exit Do
        End If
      Loop Until Flaga1 = 1
      Cls
      Call Odczyt_toc                                       'Odczytanie tablicy zawartosc utworow na plycie CD
      Pause_s = P_s                                         'zmienne okreslajace czas przerwy miedzy utworami
      Pause_f = P_f
      Track = Ilosc_track                                   'ilosc utworow na CD
      Call Odczyt_toc
      Kon_m = K_m                                           'Zapis danych o koncu zciezki CD
      Kon_s = K_s
      Kon_f = K_f
      Tmp1_m = Kon_m
      Tmp2_s = Kon_s
      Track_odtw = Ilosc_track
      Czas = 1
      Call Wyswietl                                         'wyswietla dane na LCD o
      Wait 2                                                'calkowitej liczbie utworow oraz

Tr_1:                                                       'czas trwania calej plyty CD
      Przewin = 0                                           'przez 2 sekundy
      S_czyt = 0
      Zm_pause = 1
      Zm_track = 0
      Track = 0
      Do
        Incr Track
      Loop Until W_track(track) = 1
      Call Odczyt_toc
      Call Odczyt_subchan
      Track_odtw = Track
      Z_nap = 1
      Czas = 0
      Napis = "Stop"
      Call Wyswietl
      Do                                                    'petla programu
        Debounce On_off , 0 , Onoff , Sub
        Call Rc5
        If Flag_on = 0 Then
          Cls
          Exit Do
        End If
        If S_czyt = 0 Then
          Call Odczyt_subchan                               'odczyt podkanalu z danymi o odtwarzanym utworze
          If Aud_stat = &H11 Then                           'sciezce oraz czasu relatywnego oraz absolutnego
            Call Stop_track
          End If
          Track_odtw = Track
        End If
        Call Klawiatura                                     'obsluga klawiatury
        Call Rc5
        Select Case Command
          Case Rc(2) : Kod_kl = 163
          Case Rc(3) : Kod_kl = 195
          Case Rc(4) : Kod_kl = 162
          Case Rc(5) : Kod_kl = 99
          Case Rc(6) : Kod_kl = 161
          Case Rc(7) : Kod_kl = 194
          Case Rc(8) : Kod_kl = 98
          Case Rc(9) : Kod_kl = 193
          Case Rc(10) : Kod_kl = 97
        End Select
        If Temp4 <> Kod_kl Then                             'instrukcje obslugi nacisnietych przyciskow
          Temp4 = Kod_kl
          If Kod_kl = 163 Then                              'obsluga przycisku PLAY
            Przewin = 0
            Call Odczyt_subchan
            If S_czyt = 0 Then
              Call Play_track
              Call Odczyt_subchan
              If Aud_stat = &H11 Then
                Z_nap = 1
                S_czyt = 1
                Napis = "Play "
                Tmp_w1 = 100
                Tmp_w2 = 100
                Tmp_w3 = 100
                Tmp_w4 = 100
                Czas = 1
              End If
            End If
            If Aud_stat = &H12 And S_czyt = 1 Then
              Zm_pause = 1
              Call Pause_track
              Call Odczyt_subchan
              If Aud_stat = &H11 Then
                Z_nap = 1
                Napis = "Play "
                If Zm_track = 1 Then
                  Zm_track = 0
                   Call Play_track
                End If
              End If
            End If
          End If
          If Kod_kl = 161 Then                              'obsluga klawisza wyboru wyswietlanego czasu
            Incr Fr_c
            If Fr_c = 5 Then
              Fr_c = 1
            End If
          End If
          If Kod_kl = 193 Then                              'obsluga klawisza wyboru parametrow odtwarzania sciezek
            Incr K_tr
            Z_nap = 1
            If K_tr = 4 Then
              K_tr = 1
            End If
             If S_czyt = 0 Then
              K = 0
              Do
                Incr K
                Call Klawiatura
                Waitms 10
              Loop Until Kod_kl <> 193 Or K = 200
              If K >= 200 Then
                Call Sel_track
              End If
            End If
          End If
          If Kod_kl = 97 And S_czyt = 1 Then                'obsluga szybkiego przewijania do przodu
            Przewin = 1
          End If
          If Kod_kl = 98 And S_czyt = 1 Then                'obsluga szybkiego przewijania do tylu
            Przewin = 2
          End If
          If Kod_kl = 162 Then                              'obsluga przycisku STOP
            Call Odczyt_toc
            Przewin = 0
            Call Stop_track
            Call Odczyt_subchan
            If S_czyt = 0 Then
              Goto Tr_1
            End If
            Z_nap = 1
            S_czyt = 0
            Napis = "Stop "
            Czas = 0
          End If
          If Kod_kl = 195 Then                              'Obsluga przycisku PAUSE
            Call Odczyt_subchan
            Track_odtw = Track
            If Aud_stat = &H11 Then
              Zm_pause = 0
              Call Pause_track
              Z_nap = 1
              Napis = "Pause"
            End If
            If Aud_stat = &H12 And S_czyt = 1 Then
              Zm_pause = 1
              Call Pause_track
              Call Odczyt_subchan
              If Aud_stat = &H11 Then
                Z_nap = 1
                Napis = "Play "
                If Zm_track = 1 Then
                  Zm_track = 0
                  Call Play_track
                End If
              End If
            End If
          End If
          If Kod_kl = 194 Then                              'obsluga przycisku wyboru kolejnego utworu
            Do
              Incr Track
            Loop Until Track > Ilosc_track Or W_track(track) = 1
            If Track > Ilosc_track Then
              Track = Track_odtw                            'Ilosc_track
            Else
              Przewin = 0
              Call Odczyt_toc
              Track_odtw = Track
              If S_czyt = 1 And Zm_pause = 1 Then
                Call Play_track
              End If
            End If
            If Zm_pause = 0 Then
              Call Play_track
              Do
                Call Odczyt_subchan
              Loop Until Track = Track_odtw
              Call Stop_track
              Zm_track = 1
            End If
          End If
          If Kod_kl = 99 Then                               'obsluga wyboru przycisku poprzedniego utworu
            If Rel_s <= 1 Or S_czyt = 0 Then
              Do
                Decr Track
              Loop Until Track = 0 Or W_track(track) = 1
            End If
            If Track = 0 Then
              Track = Track_odtw
            End If
            Przewin = 0
             Call Odczyt_toc
            Track_odtw = Track
            If S_czyt = 1 And Zm_pause = 1 Then
              Call Play_track
            End If
            If Zm_pause = 0 Then
              Call Play_track
              Do
                Call Odczyt_subchan
              Loop Until Track = Track_odtw
              Call Stop_track
              Zm_track = 1
            End If
          End If
        End If
        If Aud_stat = &H11 And S_czyt = 0 Then
          Call Stop_track
          Czas = 0
        End If
        If S_czyt = 1 Then
          Call Odczyt_subchan
          Call Forma_czas
        End If
        If Przewin <> 0 And Zm_pause = 1 Then               'istrukcje realizujace funkcje szybkiego przewijania
          If Przewin = 1 Then
            Incr P_s                                        'przewijanie do przodu
            Incr P_s
            Incr P_s
            P_f = 0
            If P_s >= 59 Then
              Incr P_m
              P_s = 0
            End If
            If P_s >= K_s And P_m >= K_m Then
              Call Stop_track
              Aud_stat = &H15
            Else
              Call Play_track
              Czas = 1
            End If
          Else
            Decr P_s                                        'przewijanie do tylu
            Decr P_s
            Decr P_s
            If P_s > 59 Then
              Decr P_m
              P_s = 59
            End If
            If P_m > 100 Then
              P_m = 0
              P_s = 0
              P_f = 0
            End If
            Call Play_track                                 'Jezeli przewijanie jest do tylu instrukcje sa
            Call Odczyt_subchan                             'wykonywane w zaleznosci od ustawienia
            If Track <> Track_odtw Or P_m = 0 Then          'przycisku rodzaju odtwarzania
              If Track <> Track_odtw Then
                P_m = 0
                P_s = 0
                P_f = 0
              End If
              If P_s < 4 Or P_s > 100 Then
                Call Stop_track
                If K_tr = 3 Then
                  Do
                    Track = Rnd(ilosc_track)
                    Incr Track
                  Loop Until W_track(track) = 1
                Else
                  Do
                    Decr Track
                  Loop Until Track = 0 Or W_track(track) = 1
                  If Track = 0 Then
                    If K_tr = 1 Then
                      Track = Track_odtw
                      Goto Tr_1
                    End If
                    If K_tr = 2 Then
                      Track = Ilosc_track + 1
                      Do
                        Decr Track
                      Loop Until Track = 1 Or W_track(track) = 1
                    End If
                  End If
                End If
                Call Odczyt_toc
                P_m = K_m
                P_s = K_s - 1
                P_s = P_s - Pause_s
              End If
            Else
              Call Play_track
              Czas = 1
            End If
          End If
          Waitms 50
        End If
        Call Warunki_play                                   'procedura obslugi roznych trybow odtwarzania oraz poprawnego odtwarzania utworow
        Call Wyswietl                                       'wyswietla dane o odtwarzanym utworze
        Call Czek_az_got                                    'sprawdza czy plyta nie zostala wyjeta
        If Flaga1 = 0 Then
          Goto Poczatek
        End If
      Loop Until Flag_on = 0
      Cls
    Else
      Reset Lcd_off
      Reset Led_off
      Locate 1 , 5
      Lcd Time$                                             'wyswietlenie czasu
      Locate 2 , 5
      Lcd Date$                                             'wyswietlenie daty
      Waitms 200
    End If
    Dane_l = &HE0                                           'wyslanie komendy wylaczenia napedu
    Call Wys_kom_reg
    Call Bsy_czek
  Loop
Loop
End

Sub Warunki_play                                            'Procedura realizujaca rozne funkcje odtwarzania oraz dbania o poprawna kolejnosc odtwarzania utworow
  If Aud_stat = &H15 And S_czyt = 1 Then
    If Przewin <> 0 Then
       Waitms 800
    End If
    If K_tr = 1 Then                                        'tryb 1 (Normal)
      Do
        Incr Track
      Loop Until Track > Ilosc_track Or W_track(track) = 1
      If Track > Ilosc_track Then
        Goto Tr_1
      End If
    End If
    If K_tr = 2 Then                                        'tryb 2 (Repeat)
      Do
        Incr Track
      Loop Until Track > Ilosc_track Or W_track(track) = 1
      If Track > Ilosc_track Then
        Track = 0
        Do
          Incr Track
         Loop Until W_track(track) = 1
      End If
    End If
    If K_tr = 3 Then                                        'tryb 3 (Random)
      Do
        Track = Rnd(ilosc_track)
        Incr Track
      Loop Until W_track(track) = 1
    End If
    Call Odczyt_toc
    Call Play_track
    Czas = 1
  End If
End Sub

Sub Wyswietl                                                'wyswietlanie danych na LCD
  If Track_odtw <> Tmp_w1 Then
    Locate 1 , 1
    Lcd "Track:"
    Locate 1 , 8
    If Track_odtw < 10 Then
      Lcd Bcd(track_odtw)
    Else
      Lcd Track_odtw
    End If
    Tmp_w1 = Track_odtw
  End If
  If Czas = 1 Then
    If Fr_c <> Tmp_w4 Then
      Locate 1 , 11
      If Fr_c = 2 Or Fr_c = 4 Then
        Lcd "-"
      Else
        Lcd " "
      End If
      Tmp_w4 = Fr_c
    End If
    If Tmp1_m <> Tmp_w3 Then
      Locate 1 , 12
      If Tmp1_m < 10 Then
        Lcd Bcd(tmp1_m)
      Else
        Lcd Tmp1_m
      End If
      Lcd ":"
      Tmp_w3 = Tmp1_m
    End If
    If Tmp2_s <> Tmp_w2 Then
      Locate 1 , 15
      If Tmp2_s < 10 Then
        Lcd Bcd(tmp2_s)
      Else
        Lcd Tmp2_s
      End If
      Tmp_w2 = Tmp2_s
    End If
  Else
    Locate 1 , 11
    Lcd "      "
  End If
  If Z_nap = 1 Then
    Locate 2 , 1
    Z_nap = 0
    Lcd Napis
    Locate 2 , 11
    Select Case K_tr
      Case 1 : Lcd "Normal"
      Case 2 : Lcd "Repeat"
      Case 3 : Lcd "Random"
    End Select
  End If
End Sub

Sub Klawiatura                                              'obsluga klawiatury
  Conf = Conf Or &B11100000
  Kod_kl = 0
  For N = 1 To 3
    Select Case N
      Case 1:
        Reset Conf.5
      Case 2:
        Set Conf.5
        Reset Conf.6
      Case 3:
        Set Conf.6
        Reset Conf.7
    End Select
    Ddra = &B11111111
    Porta = Conf
    Set Zat
    Waitms 1
    Reset Zat
    Ddra = &B00000000
    If W1 = 0 Then
      Kod_kl = 1
      Exit For
    Elseif W2 = 0 Then
      Kod_kl = 2
      Exit For
    Elseif W3 = 0 Then
      Kod_kl = 3
      Exit For
    End If
  Next N
  If Kod_kl <> 0 Then
    N = Conf And &B11100000
    Kod_kl = Kod_kl + N
  End If
  Waitms 10
End Sub

Sub Ident_nap                                               'identyfikacja napedu
  Dane_l = &H02
  Call Wys_h_r
  Dane_l = &H00
  Call Wys_l_r
  Dane_l = &HA1
  Call Wys_kom_reg
  Call Czek_int
  Call Pob_dane                                             'odczyt dlugosci pakietu danych
  If Dane_l.0 = 0 And Dane_l.1 = 0 Then
    Dlug_pak = 12
  End If
  If Dane_l.0 = 0 And Dane_l.1 = 1 Then
    Dlug_pak = 16
  End If
  For I = 1 To 26                                           'pobranie oraz wyswietlenie danych nazwy modelu CD-ROM
    Call Pob_dane
  Next I
  Call Reszt_dan
  Call Bsy_drdy_czek
End Sub

Sub Czek_int                                                'czekaj az na linii przerwania bedzie stan wysoki
  Do
    Set Portd.3
  Loop Until Intrq = 1
End Sub

Sub Reszt_dan                                               'Pobiera reszte niepotrzebnych danych
  Do
    Call Pob_stat
    If Status.3 = 0 Then
      Exit Do
    End If
    Call Pob_dane
  Loop
End Sub

Sub Csa                                                     'wybor linii CS/
  Reset Conf.3
  Set Conf.4
End Sub

Sub Init_cd                                                 'Inicjacja napedu
  Call Bsy_czek
  Call Pob_wyb_nap
  Reset Dane_l.4
  Call Wys_wyb_nap
  Call Bsy_czek
  Call Pob_l_r
  If Dane_l <> &H14 Then
    Call Blad_cd
  End If
  Call Pob_h_r
  If Dane_l <> &HEB Then
    Call Blad_cd
  End If
  Dane_l = &H90                                             'wyslanie komendy diagnostyki napedu
  Call Wys_kom_reg
  Call Bsy_czek
  Call Pob_err
  If Error.0 = 0 Then
    Call Blad_cd
  End If
End Sub

Sub Bsy_czek                                                'Czekaj az bit zajetosci BSY rejestru status bedzie niski
  Do
    Delay
    Call Pob_stat
  Loop Until Status.7 = 0
End Sub

Sub Pob_stat                                                'Pobranie rejestru statusu
  Set Conf.0                                                'ustawienie linii da0
  Set Conf.1                                                'da1
  Set Conf.2                                                'da2
  Call Csa
  Call Zatrzasnij
  Call Read_1b
  Status = Dane_l
End Sub

Sub Pob_int                                                 'pobranie rejestru przyczyny przerwania
  Reset Conf.0
  Set Conf.1
  Reset Conf.2
  Call Csa
  Call Zatrzasnij
  Call Read_1b
End Sub

Sub Pob_err                                                 'pobranie rejestru bledow
  Set Conf.0
  Reset Conf.1
  Reset Conf.2
  Call Csa
  Call Zatrzasnij
  Call Read_1b
  Error = Dane_l
End Sub

Sub Pob_wyb_nap                                             'odczyt rejestru wyboru napedu
  Reset Conf.0
  Set Conf.1
  Set Conf.2
  Call Csa
  Call Zatrzasnij
  Call Read_1b
End Sub

Sub Wys_wyb_nap                                             'Zapis do rejestru wybor napedu
  Reset Conf.0
  Set Conf.1
  Set Conf.2
  Call Csa
  Call Zatrzasnij
  Call Write_1b
End Sub

Sub Wys_dane1b                                              'wyslanie 1 bajta danych
  Reset Conf.0
  Reset Conf.1
  Reset Conf.2
  Call Csa
  Call Zatrzasnij
  Call Write_1b
End Sub

Sub Wys_dane2b                                              'wyslanie slowa danych (slowo = 2 bajty)
  Reset Conf.0
  Reset Conf.1
  Reset Conf.2
  Call Csa
  Call Zatrzasnij
  Call Write_2b
End Sub

Sub Pob_dane                                                'Pobranie slowa danych
  Reset Conf.0
  Reset Conf.1
  Reset Conf.2
  Call Csa
  Call Zatrzasnij
  Call Read_2b
End Sub

Sub Wys_kom_reg                                             'zapis do rejestru komend
  Set Conf.0
  Set Conf.1
  Set Conf.2
  Call Csa
  Call Zatrzasnij
  Call Write_1b
End Sub

Sub Wys_h_r                                                 'Wyslanie do licznika MSB bajta slowa
  Set Conf.0
  Reset Conf.1
  Set Conf.2
  Call Csa
  Call Zatrzasnij
  Call Write_1b
End Sub

Sub Wys_l_r                                                 'Wyslanie do licznika LSB bajta slowa
  Reset Conf.0
  Reset Conf.1
  Set Conf.2
  Call Csa
  Call Zatrzasnij
  Call Write_1b
End Sub

Sub Pob_l_r                                                 'Pobranie od licznika LSB bajta slowa
  Reset Conf.0
  Reset Conf.1
  Set Conf.2
  Call Csa
  Call Zatrzasnij
  Call Read_1b
End Sub

Sub Pob_h_r                                                 'Pobranie od licznika MSB bajta slowa
  Set Conf.0
  Reset Conf.1
  Set Conf.2
  Call Csa
  Call Zatrzasnij
  Call Read_1b
  End Sub

Sub Zatrzasnij                                              'Zatrzasniecie danych w zatrzasku U3
  Ddra = &B11111111
  Porta = Conf
  Set Zat
  Waitms 1
  Reset Zat
  Ddra = &B00000000
End Sub

Sub Read_1b                                                 'Odczyt 1 bajta danych
  Porta = 0
  Reset Dior
  Delay
  Dane_l = Pina
  Set Dior
End Sub

Sub Read_2b                                                 'Odczyt slowa
  Porta = 0
  Portc = 0
  Reset Dior
  Dane_l = Pina
  Dane_h = Pinc
  Set Dior
End Sub

Sub Write_1b                                                'Wyslanie 1 bajta danych
  Ddra = &B11111111
  Porta = Dane_l
  Reset Diow
  Delay
  Set Diow
  Ddra = &B00000000
  Porta = 0
End Sub

Sub Write_2b                                                'Wyslanie slowa
  Ddra = &B11111111
  Ddrc = &B11111111
  Porta = Dane_l
  Portc = Dane_h
  Reset Diow
  Delay
  Set Diow
  Ddra = &B00000000
  Ddrc = &B00000000
  Porta = 0
  Portc = 0
End Sub

Sub Bsy_drdy_czek                                           'czekaj az bsy=0 oraz drdy=1
  Do
    Delay
    Waitms 50
    Call Pob_stat
  Loop Until Status.7 = 0 And Status.6 = 1
End Sub

Sub Czek_az_got                                             'Czekaj az naped gotowy do odtwarzania
  For I = 1 To 2                                            'warunek spelniony jezeli wlozona zostanie plyta CD
    Call Test_got_cmd
  Next I
End Sub

Sub Drq_czek                                                'czekaj az drq=1
  Do
    Waitms 1
    Call Pob_stat
  Loop Until Status.7 = 0 And Status.3 = 1
End Sub

Sub Ndrq_czek                                               'czekaj az drq=0
  Do
    Delay
    Call Pob_stat
  Loop Until Status.7 = 0 And Status.3 = 0
End Sub

Sub Test_got_cmd                                            'testuje gotowosc napedu do odtwarzania plyty CD
  Call Zer_pak
  Call Wysl_pak
  If Status.0 = 0 Then
    Flaga1 = 1
  Else
    Flaga1 = 0
  End If
End Sub

Sub Zer_pak                                                 'zeruje dane pakietu do wyslania
  For J = 1 To 16                                           'oraz inicjalizuje przesylanie pakietu
    Pakiet(j) = 0
  Next J
  Call Ndrq_czek
  Dane_l = &HA0
  Call Wys_kom_reg
End Sub

Sub Wysl_pak                                                'wyslanie pakietu danych
  For J = 1 To Dlug_pak Step 2
    Dane_l = Pakiet(j)
    Dane_h = Pakiet(j + 1)
    Call Wys_dane2b
  Next J
  Call Czek_int
  Call Pob_stat
End Sub

Sub Odczyt_subchan                                          'odczyt podkanalu
  Dane_l = &HFF
  Call Wys_l_r
  Call Wys_h_r
  Call Zer_pak
  Pakiet(1) = &H42
  Pakiet(2) = &H02
  Pakiet(3) = &H40                                          ' Subq = 1
  Pakiet(4) = &H01
  Pakiet(8) = &HFF
  Pakiet(9) = &HFF
  Call Wysl_pak
  If Status.0 = 1 Then
    Reset Flaga3
    Exit Sub
  End If
  If Status.3 = 1 Then
    Call Pob_dan_subchan
  Else
    Reset Flaga3
  End If
End Sub

Sub Pob_dan_subchan                                         'Pobiera dane podkanalu
  Call Pob_dane
  Aud_stat = Dane_h
  Call Pob_dane
  Call Pob_dane
  Call Pob_dane
  Track_odtw = Dane_l
  Call Pob_msf
  Abs_m = Temp1
  Abs_s = Temp2
  Abs_f = Temp3
  Call Pob_msf
  Rel_m = Temp1
  Rel_s = Temp2
  Rel_f = Temp3
  Call Reszt_dan
  Set Flaga3
End Sub

Sub Odczyt_toc                                              'odczyt tablicy zawartoci wlozonego CD
  Dane_l = &HFF
  Call Wys_l_r
  Call Wys_h_r
  Call Zer_pak
  Pakiet(1) = &H43
  Pakiet(2) = &H02
  Pakiet(8) = &HFF
  Pakiet(9) = &HFF
  Call Wysl_pak
  If Status.0 = 1 Then
    Reset Flaga2
  End If
  If Status.3 = 1 Then
    Call Odczyt_dan_toc
  Else
    Reset Flaga2
  End If
End Sub

Sub Odczyt_dan_toc                                          'odczyt danych z tablicy zawartosci
  Call Pob_dane
  Call Pob_dane
  Ilosc_track = Dane_h
  Do
    Call Pob_dane
    Call Pob_dane
    Track_temp = Dane_l
    Call Pob_msf
  Loop Until Track = Track_temp
  P_m = Temp1
  P_s = Temp2
  P_f = Temp3
  Call Pob_dane
  Call Pob_dane
  Call Pob_dane
  K_m = Dane_h
  Call Pob_dane
  K_s = Dane_l
  K_f = Dane_h
  Call Bsy_czek
  Do
    If Status.3 = 1 Then
      Call Pob_dane
      Call Pob_dane
      Call Pob_dane
      Call Pob_dane
    End If
    Call Bsy_czek
  Loop Until Status.3 = 0
  Flaga2 = 1
  If K_f < Pause_f Then
    If K_s = 0 Then
      Decr K_m
      K_s = K_s + 60
    End If
    Decr K_s
    K_f = K_f + 75
  End If
  K_f = K_f - Pause_f
  If K_s < Pause_s Then
    Decr K_m
    K_s = K_s + 60
  End If
  K_s = K_s - Pause_s
End Sub

Sub Pob_msf                                                 'pobranie danych typu MSF
  Call Pob_dane
  Temp1 = Dane_h
  Call Pob_dane
  Temp2 = Dane_l
  Temp3 = Dane_h
  Call Bsy_czek
End Sub

Sub Blad_pak                                                'Procedura okreslajaca blad podczas wysylania pakietu danych
  Cls                                                       'byla wykorzystywana tylko podczas testowania
  Lcd "Blad pak nr: "                                       'programu
  Call Pob_err
  Locate 1 , 14
  Lcd Hex(error) : Lcd "h"
  Wait 3
End Sub

Sub Blad_cd                                                 'Blad komunikacji z CD-ROM
  Cls
  Lcd "Blad komunikacji"
  Wait 2
  Goto Poczatek_p
End Sub

Sub Play_track                                              'Odtwarzanie okreslonej sciezki
  Call Zer_pak
  Pakiet(1) = &H47
  Pakiet(4) = P_m                                           'poczatek sciezki
  Pakiet(5) = P_s
  Pakiet(6) = P_f
  Pakiet(7) = K_m                                           'koniec sciezki
  Pakiet(8) = K_s
  Pakiet(9) = K_f
  Call Wysl_pak
  If Status.0 = 0 Then
    Set Flaga4
  Else
    Reset Flaga4
  End If
End Sub

Sub Pause_track                                             'wyslanie pakietu danych pausy
  Call Zer_pak
  Pakiet(1) = &H4B
  Pakiet(9) = Zm_pause
  Call Wysl_pak
  If Status.0 = 0 Then
    Set Flaga4
  Else
    Reset Flaga4
  End If
End Sub

Sub Stop_track                                              'Wyslanie pakietu stop sciezki
  Call Zer_pak
  Pakiet(1) = &H4E
  Call Wysl_pak
  If Status.0 = 0 Then
    Set Flaga4
  Else
    Reset Flaga4
  End If
End Sub

Sub Odejmij_czas                                            'procedura odejmowania dwoch czasow
  If Tmp1_m = Tmp4_m And Tmp5_s => Tmp2_s Then
    Tmp1_m = 0
    Tmp2_s = 0
    Tmp3_f = 0
  Else
    Tmp1_m = Tmp1_m - Tmp4_m
    If Tmp3_f < Tmp6_f Then
      If Tmp2_s = 0 Then
        Decr Tmp1_m
        Tmp2_s = Tmp2_s + 60
      End If
      Decr Tmp2_s
      Tmp3_f = Tmp3_f + 75
    End If
    Tmp3_f = Tmp3_f - Tmp6_f
    If Tmp2_s < Tmp5_s Then
      Decr Tmp1_m
      Tmp2_s = Tmp2_s + 60
    End If
    Tmp2_s = Tmp2_s - Tmp5_s
  End If
End Sub

Sub Forma_czas                                              'Procedura wyboru formatu pokazywanego czasu
  Select Case Fr_c
    Case 1:
      Tmp1_m = Rel_m
      Tmp2_s = Rel_s
      Tmp3_f = Rel_f
    Case 2:
      Tmp1_m = K_m
      Tmp2_s = K_s
      Tmp3_f = K_f
      Tmp4_m = Abs_m
      Tmp5_s = Abs_s
      Tmp6_f = Abs_f
      Call Odejmij_czas
    Case 3:
      Tmp1_m = Abs_m
      Tmp2_s = Abs_s - 1
      Tmp3_f = Abs_f
    Case 4:
      Tmp1_m = Kon_m
      Tmp2_s = Kon_s
      Tmp3_f = Kon_f
      Tmp4_m = Abs_m
      Tmp5_s = Abs_s
      Tmp6_f = Abs_f
      Call Odejmij_czas
  End Select
End Sub


Getdatetime:                                                'pusta procedura obslugi RTC

Return

Odm_1s:                                                     'przerwanie od timer1 wywolywane co 1 sekunde
  Counter1 = Counter1 + 34286                               'natepuje w nim takrze obliczenie czasu oraz daty
  $asm
    _soft_clock:
      push r26                            ; save X pointer
      push r27
      push r16                            ; save register
      push r25                            ; save
      push r24                            ; save
       * In R24 , Sreg ; Get Sreg
      push r24                            ; save it too
      Loadadr _sec , X ; Address Of _sec Into X
      Ld r24,X                            ; get seconds
      Inc r24                             ; sec=sec+1
      St X+,r24                           ; store
      cpi r24,60                          ; >59?
      breq _soft_clock2                   ; yes
      rjmp _clock_exit                    ; no
    _soft_clock2:
      Clr R24                             ; 60 secs so reset
      st -X,r24                           ; go back set _sec to 0
      adiw XL,1                           ; advance pointer
      Ld R24,X                            ; get minutes
      inc r24                             ; minutes + 1
      st x+,r24                           ; save
      cpi r24,60                          ; >59 minutes?
      breq _soft_clock5                   ; yes
      rjmp _clock_exit                    ; no
    _soft_clock5:
      clr r24                             ; clear
      st -x,r24                           ; go back set _min to 0
      adiw xl,1                           ; advance
      ld r24,x                            ; get hours
      inc r24                             ; hours+1
      st x+,r24                           ; save hours
      cpi r24,24                          ; > 23 ? (we use mil. format)
      brne _clock_exit                    ; no
      clr r24                             ; yes
      st -x,r24                           ; hour = 0
      adiw xl,1                           ; advance pointer
      ld r24,x                            ; get days
      inc r24                             ; day + 1
      st x+,r24                           ; save days
      ld r25,x                            ; get months
      ldi r16,30                          ; try 30 days first because they are less
      cpi r25,4                           ; month is april?
      breq _clock_month                   ; found it
      cpi r25,6                           ; month is june?
      breq _clock_month                   ; found it
      cpi r25,9                           ; month is sept?
      breq _clock_month                   ; found it
      cpi r25,11                          ; month is nov?
      breq _clock_month                   ; found it
      ldi r16,28                          ; maybe feb?
      cpi r25,2                           ; feb?
      brne _Soft_clock3                   ; no must be 30 days
      adiw xl,1                           ; advance
      ld r25,x                            ; get year
      sbiw xl,1                           ; go back
      Andi R25,3                          ; leap year between 1901 and 2099?
      Brne _clock_month                   ; since 2000 is over there is no check for 2000
    _soft_clock4:
      inc r16                             ; correct days to 29
      rjmp _clock_month
    _soft_clock3:
      ldi r16,31                          ; only months with 31 days left
    _clock_month:
      cp r24,r16                          ; compare months
      brcs _clock_exit                    ; fits
      breq _clock_exit                    ; fits
      ldi r24,1                           ; reset day 1
      st -x,r24                           ; save days
      adiw xl,1                           ; advance
      ld r24,x                            ; get month
      inc r24                             ; month+1
      st x+,r24                           ; save
      cpi r24,13                          ; overflow?
      brne _clock_exit                    ; no
      ldi r24,1                           ; reset month
      st -x,r24                           ; save month = 1
      adiw xl,1                           ; advance
      ld r24,x                            ; get year
      inc r24                             ; year + 1
      st x,r24                            ; store
   _clock_exit:
      pop R24 ; Restore Used Regs
      * Out Sreg , R24
      pop r24
      pop r25
      pop r16
      pop r27
      pop r26
  $end Asm
Return

Onoff:                                                      'procedura wlaczenia/wylaczenia napedu oraz realizacji trybu kodowania pilota i ustawiania czasu
  Toggle Flag_on
  If Flag_on = 0 Then
    K = 0
    Do
      Incr K
      Waitms 15
    Loop Until On_off = 1 Or K = 200
    If K >= 200 Then
      Call Ustawienia
    End If
    Cls
    Lcd "    Power OFF"
    Wait 1
  End If
Return

Sub Rc5:                                                    'procedura odbioru kodu RC5 z pilota
  Enable Timer0
  Command = 0
  Getrc5(address , Command)                                 'obsluga transmisji RC5
  Command = Command And &B01111111
  Disable Timer0
  If Command <> Rc(1) And Setup = 0 Then
    Reset F_rc
  End If
  If Command = Rc(1) And F_rc = 0 Then
    Set F_rc
    Gosub Onoff
  End If
End Sub

Sub Ustawienia                                              'procedura ustawien kodow pilota oraz czasu i daty
  Cls
  Set Setup
  Lcd "Setup"
  K = 1
  Wait 2
  If K = 1 Then                                             'ustawienie kodow pilota
    V = 1
    Do
      Cls
      Lcd "Config RC5"
      Lowerline
      Select Case V
        Case 1 : Lcd "Power: "
        Case 2 : Lcd "Play: "
        Case 3 : Lcd "Pause: "
        Case 4 : Lcd "Stop: "
        Case 5 : Lcd "PT: "
        Case 6 : Lcd "Time: "
        Case 7 : Lcd "NT: "
        Case 8 : Lcd "PP: "
        Case 9 : Lcd "Mode: "
        Case 10 : Lcd "NN: "
      End Select
      Do
        Debounce On_off , 0 , K_set , Sub
        Call Rc5
      Loop Until Command <> 127 Or K <> 1
      If K = 1 Then
        Rc(v) = Command
        Writeeeprom Rc(v) , V
        Lcd Command
        Wait 2
        Do
          Call Rc5
        Loop Until Command = 127
        Incr V
      End If
    Loop Until V > 10 Or K <> 1
    If V > 10 Then
      K = 2
    End If
  End If
  If K = 2 Then                                             'ustawienie czasu oraz daty
    Cls
    V = 1
    Do
      Debounce On_off , 0 , K_set , Sub
      Locate 1 , 5
      Lcd Time$
      Locate 2 , 5
      Lcd Date$                                             'Date$
      Cursor On
      Select Case V
        Case 1 :
          Locate 1 , 6
          U_tk = 23
          U_tp = 0
        Case 2 :
          Locate 1 , 9
          U_tk = 59
          U_tp = 0
        Case 3 :
          Locate 1 , 12
          U_tk = 0
          U_tp = 0
        Case 4 :
          Locate 2 , 6
          U_tk = 31
          U_tp = 1
        Case 5 :
          Locate 2 , 9
          U_tk = 12
          U_tp = 1
        Case 6 :
          Locate 2 , 12
          U_tk = 99
          U_tp = 0
      End Select
      U_t(3) = _sec
      U_t(2) = _min
      U_t(1) = _hour
      U_t(4) = _day
      U_t(5) = _month
      U_t(6) = _year
      Call Klawiatura
      If Kod_kl = 99 Then
        Decr U_t(v)
        If U_t(v) > 100 Or U_t(4) = 0 Or U_t(5) = 0 Then
          U_t(v) = U_tk
        End If
        _sec = U_t(3)
        _min = U_t(2)
        _hour = U_t(1)
        _day = U_t(4)
        _month = U_t(5)
        _year = U_t(6)
      End If
      If Kod_kl = 194 Then
        Incr U_t(v)
        If U_t(v) > U_tk Then
          U_t(v) = U_tp
        End If
        _sec = U_t(3)
        _min = U_t(2)
        _hour = U_t(1)
        _day = U_t(4)
        _month = U_t(5)
        _year = U_t(6)
      End If
      If Kod_kl = 193 Then
        Incr V
        If V = 7 Then
          V = 1
        End If
      End If
      Waitms 200
    Loop Until K = 3
  End If
  Reset Setup
  Cursor Off
  Reset Flag_on
End Sub

K_set:                                                      'podprogram wywolywany po nacisnieciu przycisku Power i umozliwiajacy wybor konfiguracji
  Incr K                                                    'kodow RC5 lub czasu i daty
Return

Sub Sel_track                                               'podprogram wyboru odtwarzanych sciezek
  Cls
  Lcd "Select Track"
  Do
    Call Klawiatura
  Loop Until Kod_kl <> 193
  Lowerline
  Lcd "Track:"
  V = 1
  Do
    Call Klawiatura
    If Kod_kl = 97 Then                                     'zwieksza numer sciezki
      Incr V
      If V > Ilosc_track Then
        V = Ilosc_track
      End If
    End If
    If Kod_kl = 98 Then                                     'zmniejsza numer sciezki
      Decr V
      If V = 0 Then
        V = 1
      End If
    End If
    If Kod_kl = 161 Then                                    'umozliwia wybor czy dana sciezka ma byc odtwarzana
      X = 0
      For K = 1 To Ilosc_track
        If W_track(k) = 1 Then
          Incr X
        End If
      Next K
      If W_track(v) = 1 And X > 1 Then
        W_track(v) = 0
      Else
        W_track(v) = 1
      End If
      Waitms 200
    End If
    Locate 2 , 8
    Lcd V
    Lcd "  "
    If W_track(v) = 1 Then
      Lcd "*"
    Else
      Lcd " "
    End If
    Waitms 200
  Loop Until Kod_kl = 193                                   'podprogram wykonywany az do nacisniecia przycisku Mode
  Cls
  Track = 0
  Do
    Incr Track
  Loop Until W_track(track) = 1
  Track_odtw = Track
  Call Odczyt_toc
  Czas = 0
  Tmp_w1 = 0
  Call Wyswietl
End Sub